#ifndef __TIME_H__
#define __TIME_H__

#include <iostream>

#ifdef BUILD_DLL
    #define DLL_EXPORT __declspec(dllexport)
#else
    #define DLL_EXPORT __declspec(dllimport)
#endif


// Funciones disponibles desde programas C
#ifdef __cplusplus
extern "C"
{
#endif

int DLL_EXPORT VersionMayor();                      /**< Valor de la versión mayor a.b < a */
int DLL_EXPORT VersionMenor();                      /**< Valor de la versión menor a.b < b */

#ifdef __cplusplus
}
#endif

// Clases:

class DLL_EXPORT Tiempo {
private:
    bool positivo;                                  /**< Signo, necesario para tiempos menores de 0 */
    int hora;                                       /**< Hora */
    unsigned int minuto, segundo;                   /**< Minutos y segundos */
    void Ajustar();                                 /**< Ajusta los valores de minutos y segundos entre 0 y 59 */
public:
    Tiempo(int h, unsigned int m, unsigned int s);  /**< Constructor */
    Tiempo(int s);                                  /**< Constructor a partir de un tiempo en segundos */
    Tiempo operator+(Tiempo &t);                    /**< Suma de tiempos */
    Tiempo operator-(Tiempo &t);                    /**< Resta de tiempos */
    operator int();                                 /**< Conversión a segundos */
    int Hora() { return hora; }                     /**< Interfaz; devuelve el valor de hora */
    unsigned int Minuto() { return minuto; }        /**< Interfaz; devuelve el valor de minutos */
    unsigned int Segundo() { return segundo; }      /**< Interfaz; devuelve el valor de segundos */

/*    void Mostrar() {
        if(!positivo) std::cout << "-";
        std::cout << hora << ":";
        std::cout << minuto << ":";
        std::cout << segundo << std::endl;
    }*/
};
#endif // __TIME_H__
